#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

#define INT_VECTOR_TABLE_ADDR_IN_FLASH 0xFFF010U
#define INT_VECTOR_TABLE_SIZE 123

interrupt void API_ISR(void);
interrupt void Unimplemented_ISR(void);
interrupt void Unimplemented_ISR1(void);
interrupt void Canphyapp(void);

typedef void (*const tIsrFunc)(void);
typedef struct
{
  byte padding;
  tIsrFunc address;
} InterruptTableEntry;
#define _VECTOR(v) {0xFFU, &v}

const InterruptTableEntry _InterruptVectorTable[INT_VECTOR_TABLE_SIZE] @INT_VECTOR_TABLE_ADDR_IN_FLASH = {
		_VECTOR(Unimplemented_ISR),//123
		_VECTOR(Unimplemented_ISR),//122
		_VECTOR(Unimplemented_ISR),//121
		_VECTOR(Unimplemented_ISR),//120		
		_VECTOR(Unimplemented_ISR),//119
		_VECTOR(Unimplemented_ISR),//118
		_VECTOR(Unimplemented_ISR),//117
		_VECTOR(Unimplemented_ISR),//116
		_VECTOR(Unimplemented_ISR),//115
		_VECTOR(Unimplemented_ISR),//114
		_VECTOR(Unimplemented_ISR),//113
		_VECTOR(Unimplemented_ISR),//112
		_VECTOR(Unimplemented_ISR),//111
		_VECTOR(Unimplemented_ISR),//110
		_VECTOR(Unimplemented_ISR),//109
		_VECTOR(Unimplemented_ISR),//108		
		_VECTOR(Unimplemented_ISR),//107
		_VECTOR(Unimplemented_ISR),//106
		_VECTOR(Unimplemented_ISR),//105
		_VECTOR(Unimplemented_ISR),//104
		_VECTOR(Unimplemented_ISR),//103
		_VECTOR(Unimplemented_ISR),//102
		_VECTOR(Unimplemented_ISR),//101
		_VECTOR(Unimplemented_ISR),//100
		_VECTOR(Unimplemented_ISR),//99
		_VECTOR(Unimplemented_ISR),//98
		_VECTOR(Unimplemented_ISR),//97
		_VECTOR(Unimplemented_ISR),//96		
		_VECTOR(Unimplemented_ISR),//95
		_VECTOR(Unimplemented_ISR),//94
		_VECTOR(Unimplemented_ISR),//93
		_VECTOR(Unimplemented_ISR),//92
		_VECTOR(Unimplemented_ISR),//91
		_VECTOR(Unimplemented_ISR),//90
		_VECTOR(Unimplemented_ISR),//89
		_VECTOR(Unimplemented_ISR),//88
		_VECTOR(Unimplemented_ISR),//87
		_VECTOR(Unimplemented_ISR),//86
		_VECTOR(Unimplemented_ISR),//85
		_VECTOR(Unimplemented_ISR),//84		
		_VECTOR(Unimplemented_ISR),//83
		_VECTOR(Unimplemented_ISR),//82
		_VECTOR(Unimplemented_ISR),//81
		_VECTOR(Unimplemented_ISR),//80
		_VECTOR(Unimplemented_ISR),//79portl
		_VECTOR(Unimplemented_ISR),//78
		_VECTOR(Unimplemented_ISR),//77
		_VECTOR(Unimplemented_ISR),//76
		_VECTOR(Unimplemented_ISR),//75
		_VECTOR(Unimplemented_ISR),//74
		_VECTOR(Unimplemented_ISR),//73
		_VECTOR(Unimplemented_ISR),//72		
		_VECTOR(Unimplemented_ISR),//71
		_VECTOR(Unimplemented_ISR),//70
		_VECTOR(Unimplemented_ISR),//69
		_VECTOR(Unimplemented_ISR),//68
		_VECTOR(Unimplemented_ISR),//67
		_VECTOR(Unimplemented_ISR),//66
		_VECTOR(Unimplemented_ISR),//65
		_VECTOR(Unimplemented_ISR),//64
		//_VECTOR(Unimplemented_ISR),//0x100
		_VECTOR(API_ISR),//63
		_VECTOR(Unimplemented_ISR),//62
		_VECTOR(Unimplemented_ISR),//61
		_VECTOR(Unimplemented_ISR),//60
		_VECTOR(Unimplemented_ISR),//59
		_VECTOR(Unimplemented_ISR),//58
		_VECTOR(Unimplemented_ISR),//57
		_VECTOR(Unimplemented_ISR),//56		
		_VECTOR(Unimplemented_ISR),//55
		_VECTOR(Unimplemented_ISR),//54ps7interrupt
		_VECTOR(Canphyapp ),//53//////Canphyapp
		_VECTOR(Unimplemented_ISR),//52
		_VECTOR(Unimplemented_ISR),//51
		_VECTOR(Unimplemented_ISR),//50
		_VECTOR(Unimplemented_ISR),//49
		_VECTOR(Unimplemented_ISR),//48
		_VECTOR(Unimplemented_ISR),//47
		_VECTOR(Unimplemented_ISR),//46
		_VECTOR(Unimplemented_ISR),//45
		_VECTOR(Unimplemented_ISR),//44		
		_VECTOR(Unimplemented_ISR),//43
		_VECTOR(Unimplemented_ISR),//42    CANreceiveapp
		_VECTOR(Unimplemented_ISR),//41       can0errapp    
		_VECTOR(Unimplemented_ISR),//40
		_VECTOR(Unimplemented_ISR),//39
		_VECTOR(Unimplemented_ISR),//38
		_VECTOR(Unimplemented_ISR),//37
		_VECTOR(Unimplemented_ISR),//36
		_VECTOR(Unimplemented_ISR),//35
		_VECTOR(Unimplemented_ISR),//34
		_VECTOR(Unimplemented_ISR),//33
		_VECTOR(Unimplemented_ISR),//32		
		_VECTOR(Unimplemented_ISR),//31
		_VECTOR(Unimplemented_ISR),//30
		_VECTOR(Unimplemented_ISR),//29
		_VECTOR(Unimplemented_ISR),//28
		_VECTOR(Unimplemented_ISR),//27
		_VECTOR(Unimplemented_ISR),//26
		_VECTOR(Unimplemented_ISR),//25
		_VECTOR(Unimplemented_ISR),//24
		_VECTOR(Unimplemented_ISR),//23
		_VECTOR(Unimplemented_ISR),//22
		_VECTOR(Unimplemented_ISR),//21
		_VECTOR(Unimplemented_ISR),//20		tim0ovf
		_VECTOR(Unimplemented_ISR),//19            //tim0ch7
		_VECTOR(Unimplemented_ISR),//18
		_VECTOR(Unimplemented_ISR),//17
		_VECTOR(Unimplemented_ISR),//16
		_VECTOR(Unimplemented_ISR),//15
		_VECTOR(Unimplemented_ISR),//14
		_VECTOR(Unimplemented_ISR),//13
		_VECTOR(Unimplemented_ISR),//12
		_VECTOR(Unimplemented_ISR),//11
		_VECTOR(Unimplemented_ISR),//10
		_VECTOR(Unimplemented_ISR),//9
		_VECTOR(Unimplemented_ISR),//8		
		_VECTOR(Unimplemented_ISR),//7
		_VECTOR(Unimplemented_ISR),//6
		_VECTOR(Unimplemented_ISR1),//5
		_VECTOR(Unimplemented_ISR),//4
		_VECTOR(Unimplemented_ISR),//3
		_VECTOR(Unimplemented_ISR),//2
		_VECTOR(Unimplemented_ISR),//1
};


void delayapp(unsigned long int s);
void API_Init(void);






void API_Init(void)
{  
  CPMUAPIR = 0xFF;         //10ms interval  
//  CPMUACLKTR = 0x00;     //initial trim value
  CPMUAPICTL = 0x09;     //API osc is source of clock, interrupt disable, 
                         //clear flag if set
  CPMUAPICTL_APIFE = 1;  //API enable
  CPMUAPICTL_APIE = 1;   //interrupt enable 
} 

interrupt void API_ISR(void)
{  
	CPMUAPICTL_APIF = 1;   //clear flag
	DDRP_DDRP2=1;//led
	PTP_PTP2=~PTP_PTP2; 
	//	delay1(1000);   
}
interrupt void Unimplemented_ISR(void)
{  
	//DDRP_DDRP2=1;//led
	//	PTP_PTP2=1;
	//	PTP_PTP2=~PTP_PTP2; 		
	asm NOP;  
}
interrupt void Canphyapp(void)
{  
	 CP0IF=0xFB;	
}
interrupt void Unimplemented_ISR1(void)
{  
	DDRP_DDRP2=1;//led
		PTP_PTP2=0;
		PTP_PTP2=~PTP_PTP2; 	
	asm NOP;   //place breakpoint here
}

void main(void) {
//CPMUVREGCTL = 0x01; 
IVBR=(INT_VECTOR_TABLE_ADDR_IN_FLASH & 0xFFFFFE)>>8;;	
API_Init();
	CP0IF=0xFB;	
	
  EnableInterrupts;
  /* include your code here */

  CP0IF=0xFB;	

  for(;;) {
	 
	 // DDRP_DDRP2=1;//led
	  	//	PTP_PTP2=~PTP_PTP2;
	  	delayapp(500);
    __RESET_WATCHDOG();	/* feeds the dog */
    
  } /* loop forever */
  /* please make sure that you never leave main */

}
void delayapp(unsigned long int s) 
{
  unsigned int x,y;
  for(x = 0 ; x < 600 ; x++) 
  {
     for(y = 0 ; y < s ; y++) 
     { 
        asm(nop);
     }
  }
}
/*
void main(void) {

  EnableInterrupts;
  for(;;) {
	 
	 DDRP_DDRP2=1;//led
	  	PTP_PTP2=~PTP_PTP2;
	  	delayapp(500);
    __RESET_WATCHDOG();	
    
  } 
}*/
